/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { ContentManagerModel } from '../models';
// @ts-ignore
import { ContentManagersModel } from '../models';
// @ts-ignore
import { CreateContentManagerCommand } from '../models';
// @ts-ignore
import { Gender } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdateContentManagerCommand } from '../models';
/**
 * ContentManagersApi - axios parameter creator
 * @export
 */
export const ContentManagersApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete ContentManager. (Auth roles: Admin,Manager)
         * @param {string} contentManagerId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContentmanagersContentManagerIdDelete: async (contentManagerId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'contentManagerId' is not null or undefined
            assertParamExists('apiV1ContentmanagersContentManagerIdDelete', 'contentManagerId', contentManagerId)
            const localVarPath = `/api/v1/contentmanagers/{contentManagerId}`
                .replace(`{${"contentManagerId"}}`, encodeURIComponent(String(contentManagerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get ContentManager. (Auth roles: Admin,Manager,ContentManager)
         * @param {string} contentManagerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContentmanagersContentManagerIdGet: async (contentManagerId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'contentManagerId' is not null or undefined
            assertParamExists('apiV1ContentmanagersContentManagerIdGet', 'contentManagerId', contentManagerId)
            const localVarPath = `/api/v1/contentmanagers/{contentManagerId}`
                .replace(`{${"contentManagerId"}}`, encodeURIComponent(String(contentManagerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update ContentManager. (Auth roles: Admin,Manager,ContentManager)
         * @param {string} contentManagerId 
         * @param {UpdateContentManagerCommand} [updateContentManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContentmanagersContentManagerIdPut: async (contentManagerId: string, updateContentManagerCommand?: UpdateContentManagerCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'contentManagerId' is not null or undefined
            assertParamExists('apiV1ContentmanagersContentManagerIdPut', 'contentManagerId', contentManagerId)
            const localVarPath = `/api/v1/contentmanagers/{contentManagerId}`
                .replace(`{${"contentManagerId"}}`, encodeURIComponent(String(contentManagerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateContentManagerCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reactivate ContentManager. (Auth roles: Admin,Manager)
         * @param {string} contentManagerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContentmanagersContentManagerIdReactivatePut: async (contentManagerId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'contentManagerId' is not null or undefined
            assertParamExists('apiV1ContentmanagersContentManagerIdReactivatePut', 'contentManagerId', contentManagerId)
            const localVarPath = `/api/v1/contentmanagers/{contentManagerId}/reactivate`
                .replace(`{${"contentManagerId"}}`, encodeURIComponent(String(contentManagerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all ContentManagers. (Auth roles: Admin,Manager)
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContentmanagersGet: async (id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/contentmanagers`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (fullname !== undefined) {
                localVarQueryParameter['Fullname'] = fullname;
            }

            if (email !== undefined) {
                localVarQueryParameter['Email'] = email;
            }

            if (gender !== undefined) {
                localVarQueryParameter['Gender'] = gender;
            }

            if (dateOfBirth !== undefined) {
                localVarQueryParameter['DateOfBirth'] = (dateOfBirth as any instanceof Date) ?
                    (dateOfBirth as any).toISOString() :
                    dateOfBirth;
            }

            if (created !== undefined) {
                localVarQueryParameter['Created'] = (created as any instanceof Date) ?
                    (created as any).toISOString() :
                    created;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a ContentManager. (Auth roles: Admin,Manager)
         * @param {CreateContentManagerCommand} [createContentManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContentmanagersPost: async (createContentManagerCommand?: CreateContentManagerCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/contentmanagers`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createContentManagerCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ContentManagersApi - functional programming interface
 * @export
 */
export const ContentManagersApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ContentManagersApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete ContentManager. (Auth roles: Admin,Manager)
         * @param {string} contentManagerId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContentmanagersContentManagerIdDelete(contentManagerId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContentmanagersContentManagerIdDelete(contentManagerId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get ContentManager. (Auth roles: Admin,Manager,ContentManager)
         * @param {string} contentManagerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContentmanagersContentManagerIdGet(contentManagerId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ContentManagerModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContentmanagersContentManagerIdGet(contentManagerId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update ContentManager. (Auth roles: Admin,Manager,ContentManager)
         * @param {string} contentManagerId 
         * @param {UpdateContentManagerCommand} [updateContentManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContentmanagersContentManagerIdPut(contentManagerId: string, updateContentManagerCommand?: UpdateContentManagerCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ContentManagerModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContentmanagersContentManagerIdPut(contentManagerId, updateContentManagerCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Reactivate ContentManager. (Auth roles: Admin,Manager)
         * @param {string} contentManagerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContentmanagersContentManagerIdReactivatePut(contentManagerId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContentmanagersContentManagerIdReactivatePut(contentManagerId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all ContentManagers. (Auth roles: Admin,Manager)
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContentmanagersGet(id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ContentManagersModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContentmanagersGet(id, fullname, email, gender, dateOfBirth, created, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a ContentManager. (Auth roles: Admin,Manager)
         * @param {CreateContentManagerCommand} [createContentManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContentmanagersPost(createContentManagerCommand?: CreateContentManagerCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ContentManagerModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContentmanagersPost(createContentManagerCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * ContentManagersApi - factory interface
 * @export
 */
export const ContentManagersApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ContentManagersApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete ContentManager. (Auth roles: Admin,Manager)
         * @param {string} contentManagerId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContentmanagersContentManagerIdDelete(contentManagerId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1ContentmanagersContentManagerIdDelete(contentManagerId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get ContentManager. (Auth roles: Admin,Manager,ContentManager)
         * @param {string} contentManagerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContentmanagersContentManagerIdGet(contentManagerId: string, options?: any): AxiosPromise<ContentManagerModel> {
            return localVarFp.apiV1ContentmanagersContentManagerIdGet(contentManagerId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update ContentManager. (Auth roles: Admin,Manager,ContentManager)
         * @param {string} contentManagerId 
         * @param {UpdateContentManagerCommand} [updateContentManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContentmanagersContentManagerIdPut(contentManagerId: string, updateContentManagerCommand?: UpdateContentManagerCommand, options?: any): AxiosPromise<ContentManagerModel> {
            return localVarFp.apiV1ContentmanagersContentManagerIdPut(contentManagerId, updateContentManagerCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reactivate ContentManager. (Auth roles: Admin,Manager)
         * @param {string} contentManagerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContentmanagersContentManagerIdReactivatePut(contentManagerId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1ContentmanagersContentManagerIdReactivatePut(contentManagerId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all ContentManagers. (Auth roles: Admin,Manager)
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContentmanagersGet(id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<ContentManagersModel> {
            return localVarFp.apiV1ContentmanagersGet(id, fullname, email, gender, dateOfBirth, created, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a ContentManager. (Auth roles: Admin,Manager)
         * @param {CreateContentManagerCommand} [createContentManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContentmanagersPost(createContentManagerCommand?: CreateContentManagerCommand, options?: any): AxiosPromise<ContentManagerModel> {
            return localVarFp.apiV1ContentmanagersPost(createContentManagerCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1ContentmanagersContentManagerIdDelete operation in ContentManagersApi.
 * @export
 * @interface ContentManagersApiApiV1ContentmanagersContentManagerIdDeleteRequest
 */
export interface ContentManagersApiApiV1ContentmanagersContentManagerIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof ContentManagersApiApiV1ContentmanagersContentManagerIdDelete
     */
    readonly contentManagerId: string

    /**
     * 
     * @type {boolean}
     * @memberof ContentManagersApiApiV1ContentmanagersContentManagerIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1ContentmanagersContentManagerIdGet operation in ContentManagersApi.
 * @export
 * @interface ContentManagersApiApiV1ContentmanagersContentManagerIdGetRequest
 */
export interface ContentManagersApiApiV1ContentmanagersContentManagerIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ContentManagersApiApiV1ContentmanagersContentManagerIdGet
     */
    readonly contentManagerId: string
}

/**
 * Request parameters for apiV1ContentmanagersContentManagerIdPut operation in ContentManagersApi.
 * @export
 * @interface ContentManagersApiApiV1ContentmanagersContentManagerIdPutRequest
 */
export interface ContentManagersApiApiV1ContentmanagersContentManagerIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof ContentManagersApiApiV1ContentmanagersContentManagerIdPut
     */
    readonly contentManagerId: string

    /**
     * 
     * @type {UpdateContentManagerCommand}
     * @memberof ContentManagersApiApiV1ContentmanagersContentManagerIdPut
     */
    readonly updateContentManagerCommand?: UpdateContentManagerCommand
}

/**
 * Request parameters for apiV1ContentmanagersContentManagerIdReactivatePut operation in ContentManagersApi.
 * @export
 * @interface ContentManagersApiApiV1ContentmanagersContentManagerIdReactivatePutRequest
 */
export interface ContentManagersApiApiV1ContentmanagersContentManagerIdReactivatePutRequest {
    /**
     * 
     * @type {string}
     * @memberof ContentManagersApiApiV1ContentmanagersContentManagerIdReactivatePut
     */
    readonly contentManagerId: string
}

/**
 * Request parameters for apiV1ContentmanagersGet operation in ContentManagersApi.
 * @export
 * @interface ContentManagersApiApiV1ContentmanagersGetRequest
 */
export interface ContentManagersApiApiV1ContentmanagersGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ContentManagersApiApiV1ContentmanagersGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof ContentManagersApiApiV1ContentmanagersGet
     */
    readonly fullname?: string

    /**
     * 
     * @type {string}
     * @memberof ContentManagersApiApiV1ContentmanagersGet
     */
    readonly email?: string

    /**
     * 
     * @type {Gender}
     * @memberof ContentManagersApiApiV1ContentmanagersGet
     */
    readonly gender?: Gender

    /**
     * 
     * @type {Date}
     * @memberof ContentManagersApiApiV1ContentmanagersGet
     */
    readonly dateOfBirth?: Date

    /**
     * 
     * @type {Date}
     * @memberof ContentManagersApiApiV1ContentmanagersGet
     */
    readonly created?: Date

    /**
     * 
     * @type {boolean}
     * @memberof ContentManagersApiApiV1ContentmanagersGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof ContentManagersApiApiV1ContentmanagersGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof ContentManagersApiApiV1ContentmanagersGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof ContentManagersApiApiV1ContentmanagersGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1ContentmanagersPost operation in ContentManagersApi.
 * @export
 * @interface ContentManagersApiApiV1ContentmanagersPostRequest
 */
export interface ContentManagersApiApiV1ContentmanagersPostRequest {
    /**
     * 
     * @type {CreateContentManagerCommand}
     * @memberof ContentManagersApiApiV1ContentmanagersPost
     */
    readonly createContentManagerCommand?: CreateContentManagerCommand
}

/**
 * ContentManagersApi - object-oriented interface
 * @export
 * @class ContentManagersApi
 * @extends {BaseAPI}
 */
export class ContentManagersApi extends BaseAPI {
    /**
     * 
     * @summary Delete ContentManager. (Auth roles: Admin,Manager)
     * @param {ContentManagersApiApiV1ContentmanagersContentManagerIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContentManagersApi
     */
    public apiV1ContentmanagersContentManagerIdDelete(requestParameters: ContentManagersApiApiV1ContentmanagersContentManagerIdDeleteRequest, options?: AxiosRequestConfig) {
        return ContentManagersApiFp(this.configuration).apiV1ContentmanagersContentManagerIdDelete(requestParameters.contentManagerId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get ContentManager. (Auth roles: Admin,Manager,ContentManager)
     * @param {ContentManagersApiApiV1ContentmanagersContentManagerIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContentManagersApi
     */
    public apiV1ContentmanagersContentManagerIdGet(requestParameters: ContentManagersApiApiV1ContentmanagersContentManagerIdGetRequest, options?: AxiosRequestConfig) {
        return ContentManagersApiFp(this.configuration).apiV1ContentmanagersContentManagerIdGet(requestParameters.contentManagerId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update ContentManager. (Auth roles: Admin,Manager,ContentManager)
     * @param {ContentManagersApiApiV1ContentmanagersContentManagerIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContentManagersApi
     */
    public apiV1ContentmanagersContentManagerIdPut(requestParameters: ContentManagersApiApiV1ContentmanagersContentManagerIdPutRequest, options?: AxiosRequestConfig) {
        return ContentManagersApiFp(this.configuration).apiV1ContentmanagersContentManagerIdPut(requestParameters.contentManagerId, requestParameters.updateContentManagerCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reactivate ContentManager. (Auth roles: Admin,Manager)
     * @param {ContentManagersApiApiV1ContentmanagersContentManagerIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContentManagersApi
     */
    public apiV1ContentmanagersContentManagerIdReactivatePut(requestParameters: ContentManagersApiApiV1ContentmanagersContentManagerIdReactivatePutRequest, options?: AxiosRequestConfig) {
        return ContentManagersApiFp(this.configuration).apiV1ContentmanagersContentManagerIdReactivatePut(requestParameters.contentManagerId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all ContentManagers. (Auth roles: Admin,Manager)
     * @param {ContentManagersApiApiV1ContentmanagersGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContentManagersApi
     */
    public apiV1ContentmanagersGet(requestParameters: ContentManagersApiApiV1ContentmanagersGetRequest = {}, options?: AxiosRequestConfig) {
        return ContentManagersApiFp(this.configuration).apiV1ContentmanagersGet(requestParameters.id, requestParameters.fullname, requestParameters.email, requestParameters.gender, requestParameters.dateOfBirth, requestParameters.created, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a ContentManager. (Auth roles: Admin,Manager)
     * @param {ContentManagersApiApiV1ContentmanagersPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContentManagersApi
     */
    public apiV1ContentmanagersPost(requestParameters: ContentManagersApiApiV1ContentmanagersPostRequest = {}, options?: AxiosRequestConfig) {
        return ContentManagersApiFp(this.configuration).apiV1ContentmanagersPost(requestParameters.createContentManagerCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
