/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreatePatientManagerCommand } from '../models';
// @ts-ignore
import { Gender } from '../models';
// @ts-ignore
import { PatientManagerModel } from '../models';
// @ts-ignore
import { PatientManagersModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdatePatientManagerCommand } from '../models';
/**
 * PatientManagersApi - axios parameter creator
 * @export
 */
export const PatientManagersApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get all PatientManagers. (Auth roles: Admin,Manager)
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientmanagersGet: async (id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/patientmanagers`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (fullname !== undefined) {
                localVarQueryParameter['Fullname'] = fullname;
            }

            if (email !== undefined) {
                localVarQueryParameter['Email'] = email;
            }

            if (gender !== undefined) {
                localVarQueryParameter['Gender'] = gender;
            }

            if (dateOfBirth !== undefined) {
                localVarQueryParameter['DateOfBirth'] = (dateOfBirth as any instanceof Date) ?
                    (dateOfBirth as any).toISOString() :
                    dateOfBirth;
            }

            if (created !== undefined) {
                localVarQueryParameter['Created'] = (created as any instanceof Date) ?
                    (created as any).toISOString() :
                    created;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete PatientManager. (Auth roles: Admin,Manager)
         * @param {string} patientManagerId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientmanagersPatientManagerIdDelete: async (patientManagerId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'patientManagerId' is not null or undefined
            assertParamExists('apiV1PatientmanagersPatientManagerIdDelete', 'patientManagerId', patientManagerId)
            const localVarPath = `/api/v1/patientmanagers/{patientManagerId}`
                .replace(`{${"patientManagerId"}}`, encodeURIComponent(String(patientManagerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get PatientManager. (Auth roles: Admin,Manager,PatientManager)
         * @param {string} patientManagerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientmanagersPatientManagerIdGet: async (patientManagerId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'patientManagerId' is not null or undefined
            assertParamExists('apiV1PatientmanagersPatientManagerIdGet', 'patientManagerId', patientManagerId)
            const localVarPath = `/api/v1/patientmanagers/{patientManagerId}`
                .replace(`{${"patientManagerId"}}`, encodeURIComponent(String(patientManagerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update PatientManager. (Auth roles: Admin,Manager,PatientManager)
         * @param {string} patientManagerId 
         * @param {UpdatePatientManagerCommand} [updatePatientManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientmanagersPatientManagerIdPut: async (patientManagerId: string, updatePatientManagerCommand?: UpdatePatientManagerCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'patientManagerId' is not null or undefined
            assertParamExists('apiV1PatientmanagersPatientManagerIdPut', 'patientManagerId', patientManagerId)
            const localVarPath = `/api/v1/patientmanagers/{patientManagerId}`
                .replace(`{${"patientManagerId"}}`, encodeURIComponent(String(patientManagerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updatePatientManagerCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reactivate PatientManager. (Auth roles: Admin,Manager)
         * @param {string} patientManagerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientmanagersPatientManagerIdReactivatePut: async (patientManagerId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'patientManagerId' is not null or undefined
            assertParamExists('apiV1PatientmanagersPatientManagerIdReactivatePut', 'patientManagerId', patientManagerId)
            const localVarPath = `/api/v1/patientmanagers/{patientManagerId}/reactivate`
                .replace(`{${"patientManagerId"}}`, encodeURIComponent(String(patientManagerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a PatientManager. (Auth roles: Admin,Manager)
         * @param {CreatePatientManagerCommand} [createPatientManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientmanagersPost: async (createPatientManagerCommand?: CreatePatientManagerCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/patientmanagers`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createPatientManagerCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * PatientManagersApi - functional programming interface
 * @export
 */
export const PatientManagersApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = PatientManagersApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get all PatientManagers. (Auth roles: Admin,Manager)
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientmanagersGet(id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PatientManagersModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientmanagersGet(id, fullname, email, gender, dateOfBirth, created, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete PatientManager. (Auth roles: Admin,Manager)
         * @param {string} patientManagerId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientmanagersPatientManagerIdDelete(patientManagerId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientmanagersPatientManagerIdDelete(patientManagerId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get PatientManager. (Auth roles: Admin,Manager,PatientManager)
         * @param {string} patientManagerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientmanagersPatientManagerIdGet(patientManagerId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PatientManagerModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientmanagersPatientManagerIdGet(patientManagerId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update PatientManager. (Auth roles: Admin,Manager,PatientManager)
         * @param {string} patientManagerId 
         * @param {UpdatePatientManagerCommand} [updatePatientManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientmanagersPatientManagerIdPut(patientManagerId: string, updatePatientManagerCommand?: UpdatePatientManagerCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PatientManagerModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientmanagersPatientManagerIdPut(patientManagerId, updatePatientManagerCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Reactivate PatientManager. (Auth roles: Admin,Manager)
         * @param {string} patientManagerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientmanagersPatientManagerIdReactivatePut(patientManagerId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientmanagersPatientManagerIdReactivatePut(patientManagerId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a PatientManager. (Auth roles: Admin,Manager)
         * @param {CreatePatientManagerCommand} [createPatientManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientmanagersPost(createPatientManagerCommand?: CreatePatientManagerCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PatientManagerModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientmanagersPost(createPatientManagerCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * PatientManagersApi - factory interface
 * @export
 */
export const PatientManagersApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = PatientManagersApiFp(configuration)
    return {
        /**
         * 
         * @summary Get all PatientManagers. (Auth roles: Admin,Manager)
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientmanagersGet(id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<PatientManagersModel> {
            return localVarFp.apiV1PatientmanagersGet(id, fullname, email, gender, dateOfBirth, created, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete PatientManager. (Auth roles: Admin,Manager)
         * @param {string} patientManagerId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientmanagersPatientManagerIdDelete(patientManagerId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1PatientmanagersPatientManagerIdDelete(patientManagerId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get PatientManager. (Auth roles: Admin,Manager,PatientManager)
         * @param {string} patientManagerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientmanagersPatientManagerIdGet(patientManagerId: string, options?: any): AxiosPromise<PatientManagerModel> {
            return localVarFp.apiV1PatientmanagersPatientManagerIdGet(patientManagerId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update PatientManager. (Auth roles: Admin,Manager,PatientManager)
         * @param {string} patientManagerId 
         * @param {UpdatePatientManagerCommand} [updatePatientManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientmanagersPatientManagerIdPut(patientManagerId: string, updatePatientManagerCommand?: UpdatePatientManagerCommand, options?: any): AxiosPromise<PatientManagerModel> {
            return localVarFp.apiV1PatientmanagersPatientManagerIdPut(patientManagerId, updatePatientManagerCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reactivate PatientManager. (Auth roles: Admin,Manager)
         * @param {string} patientManagerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientmanagersPatientManagerIdReactivatePut(patientManagerId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1PatientmanagersPatientManagerIdReactivatePut(patientManagerId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a PatientManager. (Auth roles: Admin,Manager)
         * @param {CreatePatientManagerCommand} [createPatientManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientmanagersPost(createPatientManagerCommand?: CreatePatientManagerCommand, options?: any): AxiosPromise<PatientManagerModel> {
            return localVarFp.apiV1PatientmanagersPost(createPatientManagerCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1PatientmanagersGet operation in PatientManagersApi.
 * @export
 * @interface PatientManagersApiApiV1PatientmanagersGetRequest
 */
export interface PatientManagersApiApiV1PatientmanagersGetRequest {
    /**
     * 
     * @type {string}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly fullname?: string

    /**
     * 
     * @type {string}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly email?: string

    /**
     * 
     * @type {Gender}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly gender?: Gender

    /**
     * 
     * @type {Date}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly dateOfBirth?: Date

    /**
     * 
     * @type {Date}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly created?: Date

    /**
     * 
     * @type {boolean}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1PatientmanagersPatientManagerIdDelete operation in PatientManagersApi.
 * @export
 * @interface PatientManagersApiApiV1PatientmanagersPatientManagerIdDeleteRequest
 */
export interface PatientManagersApiApiV1PatientmanagersPatientManagerIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof PatientManagersApiApiV1PatientmanagersPatientManagerIdDelete
     */
    readonly patientManagerId: string

    /**
     * 
     * @type {boolean}
     * @memberof PatientManagersApiApiV1PatientmanagersPatientManagerIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1PatientmanagersPatientManagerIdGet operation in PatientManagersApi.
 * @export
 * @interface PatientManagersApiApiV1PatientmanagersPatientManagerIdGetRequest
 */
export interface PatientManagersApiApiV1PatientmanagersPatientManagerIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof PatientManagersApiApiV1PatientmanagersPatientManagerIdGet
     */
    readonly patientManagerId: string
}

/**
 * Request parameters for apiV1PatientmanagersPatientManagerIdPut operation in PatientManagersApi.
 * @export
 * @interface PatientManagersApiApiV1PatientmanagersPatientManagerIdPutRequest
 */
export interface PatientManagersApiApiV1PatientmanagersPatientManagerIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof PatientManagersApiApiV1PatientmanagersPatientManagerIdPut
     */
    readonly patientManagerId: string

    /**
     * 
     * @type {UpdatePatientManagerCommand}
     * @memberof PatientManagersApiApiV1PatientmanagersPatientManagerIdPut
     */
    readonly updatePatientManagerCommand?: UpdatePatientManagerCommand
}

/**
 * Request parameters for apiV1PatientmanagersPatientManagerIdReactivatePut operation in PatientManagersApi.
 * @export
 * @interface PatientManagersApiApiV1PatientmanagersPatientManagerIdReactivatePutRequest
 */
export interface PatientManagersApiApiV1PatientmanagersPatientManagerIdReactivatePutRequest {
    /**
     * 
     * @type {string}
     * @memberof PatientManagersApiApiV1PatientmanagersPatientManagerIdReactivatePut
     */
    readonly patientManagerId: string
}

/**
 * Request parameters for apiV1PatientmanagersPost operation in PatientManagersApi.
 * @export
 * @interface PatientManagersApiApiV1PatientmanagersPostRequest
 */
export interface PatientManagersApiApiV1PatientmanagersPostRequest {
    /**
     * 
     * @type {CreatePatientManagerCommand}
     * @memberof PatientManagersApiApiV1PatientmanagersPost
     */
    readonly createPatientManagerCommand?: CreatePatientManagerCommand
}

/**
 * PatientManagersApi - object-oriented interface
 * @export
 * @class PatientManagersApi
 * @extends {BaseAPI}
 */
export class PatientManagersApi extends BaseAPI {
    /**
     * 
     * @summary Get all PatientManagers. (Auth roles: Admin,Manager)
     * @param {PatientManagersApiApiV1PatientmanagersGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientManagersApi
     */
    public apiV1PatientmanagersGet(requestParameters: PatientManagersApiApiV1PatientmanagersGetRequest = {}, options?: AxiosRequestConfig) {
        return PatientManagersApiFp(this.configuration).apiV1PatientmanagersGet(requestParameters.id, requestParameters.fullname, requestParameters.email, requestParameters.gender, requestParameters.dateOfBirth, requestParameters.created, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete PatientManager. (Auth roles: Admin,Manager)
     * @param {PatientManagersApiApiV1PatientmanagersPatientManagerIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientManagersApi
     */
    public apiV1PatientmanagersPatientManagerIdDelete(requestParameters: PatientManagersApiApiV1PatientmanagersPatientManagerIdDeleteRequest, options?: AxiosRequestConfig) {
        return PatientManagersApiFp(this.configuration).apiV1PatientmanagersPatientManagerIdDelete(requestParameters.patientManagerId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get PatientManager. (Auth roles: Admin,Manager,PatientManager)
     * @param {PatientManagersApiApiV1PatientmanagersPatientManagerIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientManagersApi
     */
    public apiV1PatientmanagersPatientManagerIdGet(requestParameters: PatientManagersApiApiV1PatientmanagersPatientManagerIdGetRequest, options?: AxiosRequestConfig) {
        return PatientManagersApiFp(this.configuration).apiV1PatientmanagersPatientManagerIdGet(requestParameters.patientManagerId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update PatientManager. (Auth roles: Admin,Manager,PatientManager)
     * @param {PatientManagersApiApiV1PatientmanagersPatientManagerIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientManagersApi
     */
    public apiV1PatientmanagersPatientManagerIdPut(requestParameters: PatientManagersApiApiV1PatientmanagersPatientManagerIdPutRequest, options?: AxiosRequestConfig) {
        return PatientManagersApiFp(this.configuration).apiV1PatientmanagersPatientManagerIdPut(requestParameters.patientManagerId, requestParameters.updatePatientManagerCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reactivate PatientManager. (Auth roles: Admin,Manager)
     * @param {PatientManagersApiApiV1PatientmanagersPatientManagerIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientManagersApi
     */
    public apiV1PatientmanagersPatientManagerIdReactivatePut(requestParameters: PatientManagersApiApiV1PatientmanagersPatientManagerIdReactivatePutRequest, options?: AxiosRequestConfig) {
        return PatientManagersApiFp(this.configuration).apiV1PatientmanagersPatientManagerIdReactivatePut(requestParameters.patientManagerId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a PatientManager. (Auth roles: Admin,Manager)
     * @param {PatientManagersApiApiV1PatientmanagersPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientManagersApi
     */
    public apiV1PatientmanagersPost(requestParameters: PatientManagersApiApiV1PatientmanagersPostRequest = {}, options?: AxiosRequestConfig) {
        return PatientManagersApiFp(this.configuration).apiV1PatientmanagersPost(requestParameters.createPatientManagerCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
